"""autogenerated by genmsg_py from MapFeature.msg. Do not edit."""
import roslib.message
import struct

import geographic_msgs.msg

class MapFeature(roslib.message.Message):
  _md5sum = "3b97f4be98d345cc79068a6a9e9ec28b"
  _type = "geographic_msgs/MapFeature"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Geographic map feature.
#
# A list of WayPoint IDs for features like streets, highways, hiking
# trails, the outlines of buildings and parking lots in sequential
# order.
#
# Feature lists may also contain other feature lists as members.

UniqueID   id           # Unique feature identifier
UniqueID[] components   # Sequence of feature components
KeyValue[] props        # Key/value properties for this feature

================================================================================
MSG: geographic_msgs/UniqueID
# A universally unique identifier (UUID) for a geographic feature.
#
#  http://en.wikipedia.org/wiki/Universally_unique_identifier
#  http://tools.ietf.org/html/rfc4122.html
#
# For simplicity and human readability, the UUID is represented as a
# string of hex digits and dashes.
#
# UUID generation is up to the programmer, but the intent is for
# matching features within a domain such as Open Street Map to yield
# the same UUID.  The recommended method is RFC 4122 variant 5,
# computing the SHA-1 hash of a URL encoded using the map source.  For
# example:
#
#  http://openstreetmap.org/node/NUMBER
#  http://openstreetmap.org/way/NUMBER
#  http://openstreetmap.org/relation/NUMBER
#
# Here NUMBER is the decimal representation of the OSM node, way, or
# relation ID without leading zeros.
#
# Other map sources should use similar conventions.

string uuid     # format: 01234567-89ab-cdef-0123-456789abcdef

================================================================================
MSG: geographic_msgs/KeyValue
# Geographic map tag (key, value) pair
#
# This is equivalent to diagnostic_msgs/KeyValue, repeated here to
# avoid introducing a trivial stack dependency.

string key                     # tag label
string value                   # corresponding value

"""
  __slots__ = ['id','components','props']
  _slot_types = ['geographic_msgs/UniqueID','geographic_msgs/UniqueID[]','geographic_msgs/KeyValue[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       id,components,props
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(MapFeature, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.id is None:
        self.id = geographic_msgs.msg.UniqueID()
      if self.components is None:
        self.components = []
      if self.props is None:
        self.props = []
    else:
      self.id = geographic_msgs.msg.UniqueID()
      self.components = []
      self.props = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.id.uuid
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.components)
      buff.write(_struct_I.pack(length))
      for val1 in self.components:
        _x = val1.uuid
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.props)
      buff.write(_struct_I.pack(length))
      for val1 in self.props:
        _x = val1.key
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.value
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.id is None:
        self.id = geographic_msgs.msg.UniqueID()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.id.uuid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.components = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.UniqueID()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.uuid = str[start:end]
        self.components.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.props = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.value = str[start:end]
        self.props.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.id.uuid
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.components)
      buff.write(_struct_I.pack(length))
      for val1 in self.components:
        _x = val1.uuid
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.props)
      buff.write(_struct_I.pack(length))
      for val1 in self.props:
        _x = val1.key
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.value
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.id is None:
        self.id = geographic_msgs.msg.UniqueID()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.id.uuid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.components = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.UniqueID()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.uuid = str[start:end]
        self.components.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.props = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.value = str[start:end]
        self.props.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
