"""autogenerated by genmsg_py from GetGeographicMapRequest.msg. Do not edit."""
import roslib.message
import struct

import geographic_msgs.msg

class GetGeographicMapRequest(roslib.message.Message):
  _md5sum = "bcb6c922f4e40d10bb092a499c762a4e"
  _type = "geographic_msgs/GetGeographicMapRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

string url



BoundingBox bounds


================================================================================
MSG: geographic_msgs/BoundingBox
# Two-dimensional geographic map bounding box. 

# Latitudes are in degrees [-90 .. +90]. Positive is north of equator;
# negative is south.

# Longitudes are in degrees [-180 .. +180]. Positive is east of prime
# meridian; negative is west. At the poles, latitude is -90 or +90,
# and longitude is irrelevant, but must be in range.

# If all bounds are zeros, the bounding box includes the whole world.

float64 min_latitude
float64 min_longitude
float64 max_latitude
float64 max_longitude

"""
  __slots__ = ['url','bounds']
  _slot_types = ['string','geographic_msgs/BoundingBox']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       url,bounds
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GetGeographicMapRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.url is None:
        self.url = ''
      if self.bounds is None:
        self.bounds = geographic_msgs.msg.BoundingBox()
    else:
      self.url = ''
      self.bounds = geographic_msgs.msg.BoundingBox()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.url
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.bounds.min_latitude, _x.bounds.min_longitude, _x.bounds.max_latitude, _x.bounds.max_longitude))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.bounds is None:
        self.bounds = geographic_msgs.msg.BoundingBox()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.url = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.bounds.min_latitude, _x.bounds.min_longitude, _x.bounds.max_latitude, _x.bounds.max_longitude,) = _struct_4d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.url
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.bounds.min_latitude, _x.bounds.min_longitude, _x.bounds.max_latitude, _x.bounds.max_longitude))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.bounds is None:
        self.bounds = geographic_msgs.msg.BoundingBox()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.url = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.bounds.min_latitude, _x.bounds.min_longitude, _x.bounds.max_latitude, _x.bounds.max_longitude,) = _struct_4d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_4d = struct.Struct("<4d")
"""autogenerated by genmsg_py from GetGeographicMapResponse.msg. Do not edit."""
import roslib.message
import struct

import geographic_msgs.msg
import std_msgs.msg

class GetGeographicMapResponse(roslib.message.Message):
  _md5sum = "76dd945577593220b7bed16a38543c19"
  _type = "geographic_msgs/GetGeographicMapResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
bool success
string status


geographic_msgs/GeographicMap map


================================================================================
MSG: geographic_msgs/GeographicMap
# Geographic map for a specified region.

Header header            # stamp specifies time
                         # frame_id (normally /map)

UniqueID     id          # identifier for this map
BoundingBox  bounds      # 2D bounding box containing map

WayPoint[]   points      # way-points
MapFeature[] features    # map features
KeyValue[]   props       # map properties

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geographic_msgs/UniqueID
# A universally unique identifier (UUID) for a geographic feature.
#
#  http://en.wikipedia.org/wiki/Universally_unique_identifier
#  http://tools.ietf.org/html/rfc4122.html
#
# For simplicity and human readability, the UUID is represented as a
# string of hex digits and dashes.
#
# UUID generation is up to the programmer, but the intent is for
# matching features within a domain such as Open Street Map to yield
# the same UUID.  The recommended method is RFC 4122 variant 5,
# computing the SHA-1 hash of a URL encoded using the map source.  For
# example:
#
#  http://openstreetmap.org/node/NUMBER
#  http://openstreetmap.org/way/NUMBER
#  http://openstreetmap.org/relation/NUMBER
#
# Here NUMBER is the decimal representation of the OSM node, way, or
# relation ID without leading zeros.
#
# Other map sources should use similar conventions.

string uuid     # format: 01234567-89ab-cdef-0123-456789abcdef

================================================================================
MSG: geographic_msgs/BoundingBox
# Two-dimensional geographic map bounding box. 

# Latitudes are in degrees [-90 .. +90]. Positive is north of equator;
# negative is south.

# Longitudes are in degrees [-180 .. +180]. Positive is east of prime
# meridian; negative is west. At the poles, latitude is -90 or +90,
# and longitude is irrelevant, but must be in range.

# If all bounds are zeros, the bounding box includes the whole world.

float64 min_latitude
float64 min_longitude
float64 max_latitude
float64 max_longitude

================================================================================
MSG: geographic_msgs/WayPoint
# Way-point element for a geographic map.

UniqueID   id           # Unique way-point identifier
GeoPoint   position     # Position relative to WGS 84 ellipsoid
KeyValue[] props        # Key/value properties for this point

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

================================================================================
MSG: geographic_msgs/KeyValue
# Geographic map tag (key, value) pair
#
# This is equivalent to diagnostic_msgs/KeyValue, repeated here to
# avoid introducing a trivial stack dependency.

string key                     # tag label
string value                   # corresponding value

================================================================================
MSG: geographic_msgs/MapFeature
# Geographic map feature.
#
# A list of WayPoint IDs for features like streets, highways, hiking
# trails, the outlines of buildings and parking lots in sequential
# order.
#
# Feature lists may also contain other feature lists as members.

UniqueID   id           # Unique feature identifier
UniqueID[] components   # Sequence of feature components
KeyValue[] props        # Key/value properties for this feature

"""
  __slots__ = ['success','status','map']
  _slot_types = ['bool','string','geographic_msgs/GeographicMap']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       success,status,map
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GetGeographicMapResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.status is None:
        self.status = ''
      if self.map is None:
        self.map = geographic_msgs.msg.GeographicMap()
    else:
      self.success = False
      self.status = ''
      self.map = geographic_msgs.msg.GeographicMap()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      buff.write(_struct_B.pack(self.success))
      _x = self.status
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.map.header.seq, _x.map.header.stamp.secs, _x.map.header.stamp.nsecs))
      _x = self.map.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.map.id.uuid
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.map.bounds.min_latitude, _x.map.bounds.min_longitude, _x.map.bounds.max_latitude, _x.map.bounds.max_longitude))
      length = len(self.map.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.map.points:
        _v1 = val1.id
        _x = _v1.uuid
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v2 = val1.position
        _x = _v2
        buff.write(_struct_3d.pack(_x.latitude, _x.longitude, _x.altitude))
        length = len(val1.props)
        buff.write(_struct_I.pack(length))
        for val2 in val1.props:
          _x = val2.key
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2.value
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.map.features)
      buff.write(_struct_I.pack(length))
      for val1 in self.map.features:
        _v3 = val1.id
        _x = _v3.uuid
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.components)
        buff.write(_struct_I.pack(length))
        for val2 in val1.components:
          _x = val2.uuid
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.props)
        buff.write(_struct_I.pack(length))
        for val2 in val1.props:
          _x = val2.key
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2.value
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.map.props)
      buff.write(_struct_I.pack(length))
      for val1 in self.map.props:
        _x = val1.key
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.value
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.map is None:
        self.map = geographic_msgs.msg.GeographicMap()
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.map.header.seq, _x.map.header.stamp.secs, _x.map.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.map.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.map.id.uuid = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.map.bounds.min_latitude, _x.map.bounds.min_longitude, _x.map.bounds.max_latitude, _x.map.bounds.max_longitude,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.map.points = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.WayPoint()
        _v4 = val1.id
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v4.uuid = str[start:end]
        _v5 = val1.position
        _x = _v5
        start = end
        end += 24
        (_x.latitude, _x.longitude, _x.altitude,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.props = []
        for i in range(0, length):
          val2 = geographic_msgs.msg.KeyValue()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.value = str[start:end]
          val1.props.append(val2)
        self.map.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.map.features = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.MapFeature()
        _v6 = val1.id
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v6.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.components = []
        for i in range(0, length):
          val2 = geographic_msgs.msg.UniqueID()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.uuid = str[start:end]
          val1.components.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.props = []
        for i in range(0, length):
          val2 = geographic_msgs.msg.KeyValue()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.value = str[start:end]
          val1.props.append(val2)
        self.map.features.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.map.props = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.value = str[start:end]
        self.map.props.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      buff.write(_struct_B.pack(self.success))
      _x = self.status
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.map.header.seq, _x.map.header.stamp.secs, _x.map.header.stamp.nsecs))
      _x = self.map.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.map.id.uuid
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4d.pack(_x.map.bounds.min_latitude, _x.map.bounds.min_longitude, _x.map.bounds.max_latitude, _x.map.bounds.max_longitude))
      length = len(self.map.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.map.points:
        _v7 = val1.id
        _x = _v7.uuid
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v8 = val1.position
        _x = _v8
        buff.write(_struct_3d.pack(_x.latitude, _x.longitude, _x.altitude))
        length = len(val1.props)
        buff.write(_struct_I.pack(length))
        for val2 in val1.props:
          _x = val2.key
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2.value
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.map.features)
      buff.write(_struct_I.pack(length))
      for val1 in self.map.features:
        _v9 = val1.id
        _x = _v9.uuid
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.components)
        buff.write(_struct_I.pack(length))
        for val2 in val1.components:
          _x = val2.uuid
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.props)
        buff.write(_struct_I.pack(length))
        for val2 in val1.props:
          _x = val2.key
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2.value
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.map.props)
      buff.write(_struct_I.pack(length))
      for val1 in self.map.props:
        _x = val1.key
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.value
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.map is None:
        self.map = geographic_msgs.msg.GeographicMap()
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.map.header.seq, _x.map.header.stamp.secs, _x.map.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.map.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.map.id.uuid = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.map.bounds.min_latitude, _x.map.bounds.min_longitude, _x.map.bounds.max_latitude, _x.map.bounds.max_longitude,) = _struct_4d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.map.points = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.WayPoint()
        _v10 = val1.id
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v10.uuid = str[start:end]
        _v11 = val1.position
        _x = _v11
        start = end
        end += 24
        (_x.latitude, _x.longitude, _x.altitude,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.props = []
        for i in range(0, length):
          val2 = geographic_msgs.msg.KeyValue()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.value = str[start:end]
          val1.props.append(val2)
        self.map.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.map.features = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.MapFeature()
        _v12 = val1.id
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v12.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.components = []
        for i in range(0, length):
          val2 = geographic_msgs.msg.UniqueID()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.uuid = str[start:end]
          val1.components.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.props = []
        for i in range(0, length):
          val2 = geographic_msgs.msg.KeyValue()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.value = str[start:end]
          val1.props.append(val2)
        self.map.features.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.map.props = []
      for i in range(0, length):
        val1 = geographic_msgs.msg.KeyValue()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.value = str[start:end]
        self.map.props.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_B = struct.Struct("<B")
_struct_4d = struct.Struct("<4d")
_struct_3d = struct.Struct("<3d")
class GetGeographicMap(roslib.message.ServiceDefinition):
  _type          = 'geographic_msgs/GetGeographicMap'
  _md5sum = '325e956ec3ca3be5597312537c09d9f8'
  _request_class  = GetGeographicMapRequest
  _response_class = GetGeographicMapResponse
